package eu.mhsl.craftattack.worldmuseum.worlds;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class WorldManager {
    private static WorldManager instance;
    private final List<World> worlds = new ArrayList<>();

    public static WorldManager getInstance() {
        if (instance == null) {
            instance = new WorldManager();
        }
        return instance;
    }
    public void loadWorlds() {
        File saveDirectory = new File("saves");
        List<File> worldFolders = getFolderNames(saveDirectory);
        for (File f: worldFolders
        ) {
            World w = new World(f);
            if (w.isEnabled()) {
                worlds.add(w);
            } else {
                System.out.println("Es gibt eine nicht aktivierte Welt: " + f);
            }
        }
    }

    private List<File> getFolderNames(File curDir) {
        File[] fileList = curDir.listFiles();
        List<File> returnFolders = new ArrayList<>();
        assert fileList != null;
        for (File f: fileList) {
            if (f.isDirectory()) returnFolders.add(f);
        }
        return returnFolders;
    }

    public List<World> getWorlds() {
        return worlds;
    }
}
